/*
 * Copyright (C) 2007 - John Anderson, Neil Kettle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <stdio.h>
#include <stdlib.h>

#ifdef DEBUG
#include <assert.h>
#endif

#include <stdarg.h>
#include <string.h>
#include <unistd.h>

#include "synscan.h"

static char
file_getc (int fd)
{
  char c;

  if (read (fd, &c, sizeof c) != 1 || c < 1)
    return (-1);

  return (c);
}

int
file_getline (int fd, char *buf, int len)
{
  char *ptr;

  ptr = buf;
  while (--len >= 0) {
    int c = file_getc (fd);
    if (c == '\n' || c == -1)
      break;
    else if (c != '\r')
      *ptr++ = c;
  }

  if (len)
    *ptr = '\0';

  return ((int) (ptr - buf));
}
